<template>

	<div>

		<div class="jumbotron jumbotron-fluid">

			<div class="container">

				<h1 class="display-3">Your basket</h1>

				<p class="lead">Please find all products you added to your basket.</p>

				<div v-if="products.length">

					<h3>Total : <span class="badge badge-info">{{total}}</span></h3>

					<h3>Total after discount : <span class="badge badge-success">{{discount}}</span></h3>

				</div>

			</div>

		</div>

		<div v-if="products.length">

			<div class="card-deck">

				<product :checkout="true" :product="product" v-for="product in products"></product>

			</div>

		</div>

		<div v-else class="alert alert-warning" role="alert">

			<h4 class="alert-heading">Your basket is empty !</h4>

			<p>Go back to the product listing in order to add new product in you basket</p>

			<p class="mb-0">

				<router-link class="btn btn-primary" to="/" active-class="active">Product listing</router-link>

			</p>

		</div>

	</div>

</template>

<script>

import Product from 'components/Product';

import { mapGetters, mapActions } from 'vuex';

import { ADD_TO_CART, REMOVE_FROM_CART } from '../vuex/mutation-types';

export default {

	name: 'checkout',

	created() {

		this.$store.subscribe(this.onStoreSubscribe);

		if (this.products.length) {

			this.checkout();

		}

	},

	computed: mapGetters({

		products: 'allProductsAdded',
		total: 'totalProductsAdded',
		discount: 'discountProductsAdded',
	}),

	methods: {

		onStoreSubscribe(mutation) {

			const { type } = mutation;

			if ((type === ADD_TO_CART || type === REMOVE_FROM_CART) && this.products.length) {

				this.$store.dispatch('checkout');

			}

		},

		...mapActions([

			'checkout',

		]),

	},

	components: {

		Product,

	},

};

</script>

<style scoped>

	.card-group {

		justify-content: space-between;
	}

</style>
